public inbox for fstests@vger.kernel.org
 help / color / mirror / Atom feed
From: Xiong Zhou <xzhou@redhat.com>
To: fstests@vger.kernel.org
Cc: linux-unionfs@vger.kernel.org, mszeredi@redhat.com,
	Xiong Zhou <xzhou@redhat.com>
Subject: [xfstests v3 5/8] overlay: filter out xattr starts with "trusted.overlay."
Date: Mon, 20 Feb 2017 16:48:41 +0800	[thread overview]
Message-ID: <1487580524-21503-6-git-send-email-xzhou@redhat.com> (raw)
In-Reply-To: <1487580524-21503-1-git-send-email-xzhou@redhat.com>

Not "trusted.overlay".
  "trusted.overlayxxx" is allowed.
  "trusted.overlay.xxx" is not allowed.

CC: Miklos Szeredi <mszeredi@redhat.com>
Signed-off-by: Xiong Zhou <xzhou@redhat.com>
---
 tests/overlay/026     | 99 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/overlay/026.out |  5 +++
 tests/overlay/group   |  1 +
 3 files changed, 105 insertions(+)
 create mode 100755 tests/overlay/026
 create mode 100644 tests/overlay/026.out

diff --git a/tests/overlay/026 b/tests/overlay/026
new file mode 100755
index 0000000..86f73ea
--- /dev/null
+++ b/tests/overlay/026
@@ -0,0 +1,99 @@
+#! /bin/bash
+# FS QA Test 026
+#
+# Overlayfs should only filter out xattr starting with
+# "trusted.overlay.", not "trusted.overlay".
+# Setting xattrs like "trusted.overlay.xxx" is not allowed.
+# Setting xattrs like "trusted.overlayxxx" is allowed.
+#
+# Kernel commit below fixed it.
+# fe2b75952347 ovl: Fix OVL_XATTR_PREFIX
+#
+# This reproducer was originally written by
+#     Miklos Szeredi <mszeredi@redhat.com>
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Red Hat Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/attr
+. ./common/filter
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs overlay
+_supported_os Linux
+_require_scratch
+_require_attrs
+
+# Remove all files from previous tests
+_scratch_mkfs
+
+# Mounting overlay
+_scratch_mount
+touch $SCRATCH_MNT/testf0
+touch $SCRATCH_MNT/testf1
+
+# {s,g}etfattr of "trusted.overlayxxx" should work.
+$SETFATTR_PROG -n "trusted.overlayfsrz" -v "n" \
+  $SCRATCH_MNT/testf0
+
+$GETFATTR_PROG -n "trusted.overlayfsrz" $SCRATCH_MNT/testf0 \
+  2>&1 | sed -e "s,${SCRATCH_MNT#/},SCRATCH_MNT,g" \
+	     -e "/Removing leading/ d" \
+	     -e "/^$/ d"
+
+# {s,g}etfattr of "trusted.overlay.xxx" should fail.
+# The errno returned varies between kernel versions,
+#            v4.3       v4.7       v4.8      v4.10
+# setfattr  not perm  not perm   not perm   not supp
+# getfattr  no attr   no attr    not perm   not supp
+#
+# Checking the latest(not supported).
+#
+$SETFATTR_PROG -n "trusted.overlay.fsz" -v "n" \
+  $SCRATCH_MNT/testf1 2>&1 | \
+  sed -e "s,${SCRATCH_MNT},SCRATCH_MNT,g" \
+
+$GETFATTR_PROG -n "trusted.overlay.fsz" \
+  $SCRATCH_MNT/testf1 2>&1 | \
+  sed -e "s,${SCRATCH_MNT},SCRATCH_MNT,g" \
+
+# success, all done
+status=0
+exit
diff --git a/tests/overlay/026.out b/tests/overlay/026.out
new file mode 100644
index 0000000..94da51b
--- /dev/null
+++ b/tests/overlay/026.out
@@ -0,0 +1,5 @@
+QA output created by 026
+# file: SCRATCH_MNT/testf0
+trusted.overlayfsrz="n"
+setfattr: SCRATCH_MNT/testf1: Operation not supported
+SCRATCH_MNT/testf1: trusted.overlay.fsz: Operation not supported
diff --git a/tests/overlay/group b/tests/overlay/group
index 82fe69e..92afa8d 100644
--- a/tests/overlay/group
+++ b/tests/overlay/group
@@ -28,3 +28,4 @@
 023 auto quick attr
 024 auto quick
 025 auto quick attr
+026 auto attr quick
-- 
1.8.3.1


  parent reply	other threads:[~2017-02-20  8:49 UTC|newest]

Thread overview: 14+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2017-02-20  8:48 [xfstests v3 0/8] bunch of overlay tests Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 1/8] overlay: disallow overlayfs as upperdir Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 2/8] overlay: work dir in overlay inherits no ACLs Xiong Zhou
2017-02-21  6:04   ` Eryu Guan
2017-02-20  8:48 ` [xfstests v3 3/8] overlay: test workdir cleanup in mounting Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 4/8] overlay: permission check with cached acls in tmpfs Xiong Zhou
2017-02-21  6:18   ` Eryu Guan
2017-02-20  8:48 ` Xiong Zhou [this message]
2017-02-21  6:23   ` [xfstests v3 5/8] overlay: filter out xattr starts with "trusted.overlay." Eryu Guan
2017-02-22  5:58     ` Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 6/8] overlay: can not change underlying immutable file Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 7/8] overlay: test flock after copied up Xiong Zhou
2017-02-20  8:48 ` [xfstests v3 8/8] overlay: accessing stacked overlayfs files Xiong Zhou
     [not found] ` <CAOQ4uxhzYPkp3YHEuGHrvQ8+0SCmQuiXDO=2osOAga2NEWeZUw@mail.gmail.com>
2017-02-21  5:23   ` [xfstests v3 0/8] bunch of overlay tests Eryu Guan

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1487580524-21503-6-git-send-email-xzhou@redhat.com \
    --to=xzhou@redhat.com \
    --cc=fstests@vger.kernel.org \
    --cc=linux-unionfs@vger.kernel.org \
    --cc=mszeredi@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox